package com.sxtvs.open.core.auth;

import cn.hutool.core.util.IdUtil;
import org.springframework.web.context.request.RequestAttributes;
import org.springframework.web.context.request.RequestContextHolder;

import java.util.Optional;

public class HttpContextUtil {
    public static Optional<String> getRequestId() {
        return Optional.ofNullable(RequestContextHolder.getRequestAttributes())
                .map(x -> x.getAttribute("requestId", RequestAttributes.SCOPE_REQUEST))
                .map(Object::toString);
    }

    public static String mustRequestId() {
        return Optional.ofNullable(RequestContextHolder.getRequestAttributes())
                .map(x -> x.getAttribute("requestId", RequestAttributes.SCOPE_REQUEST))
                .map(Object::toString)
                .orElse("");
    }

    public static void setRequestId() {
        Optional.ofNullable(RequestContextHolder.getRequestAttributes())
                .ifPresent(x -> {
                    var requestId = IdUtil.nanoId();
                    x.setAttribute("requestId", requestId, RequestAttributes.SCOPE_REQUEST);
                });
    }

    public static Optional<String> getToken() {
        return Optional.ofNullable(RequestContextHolder.getRequestAttributes())
                .map(x -> x.getAttribute("token", RequestAttributes.SCOPE_REQUEST))
                .map(Object::toString);
    }

    public static void setToken(String token) {
        Optional.ofNullable(RequestContextHolder.getRequestAttributes())
                .ifPresent(x -> x.setAttribute("token", token, RequestAttributes.SCOPE_REQUEST));
    }
}
