package com.sxtvs.open.core.auth;


import com.sxtvs.open.core.advice.BizException;
import com.sxtvs.open.core.conf.Constant;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.web.method.HandlerMethod;
import org.springframework.web.servlet.AsyncHandlerInterceptor;

import java.lang.reflect.Method;

public class LoginInterceptor implements AsyncHandlerInterceptor {
    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) {
        if (!(handler instanceof HandlerMethod handlerMethod)) {
            return true;
        }
        HttpContextUtil.setRequestId();
        Method method = handlerMethod.getMethod();

        LoginRequired methodAnnotation = method.getAnnotation(LoginRequired.class);
        if (methodAnnotation == null) {
            return true;
        }

        // 这写你拦截需要干的事儿，比如取缓存，SESSION，权限判断等
        String token = request.getHeader(Constant.TOKEN_HEADER_NAME);

        if (!AESUtil.isOk(token)) {
            throw new BizException("没有登录");
        }
        HttpContextUtil.setToken(token);

        return true;
    }
}
